import { ref as g, onMounted as M, onUnmounted as N, defineComponent as E, createElementBlock as T, openBlock as B, normalizeClass as L, renderSlot as $ } from "vue";
const d = `<svg 
  class="copy-code-vue-fade-in"
  xmlns="http://www.w3.org/2000/svg" 
  width="16" 
  height="16" 
  viewBox="0 0 24 24" 
  fill="none" 
  stroke="currentColor" 
  stroke-width="2" 
  stroke-linecap="round" 
  stroke-linejoin="round"
>
  <rect width="14" height="14" x="8" y="8" rx="2" ry="2"/>
  <path d="M4 16c-1.1 0-2-.9-2-2V4c0-1.1.9-2 2-2h10c1.1 0 2 .9 2 2"/>
</svg>`, H = `<svg 
  xmlns="http://www.w3.org/2000/svg" 
  width="16" 
  height="16" 
  viewBox="0 0 24 24" 
  fill="none" 
  stroke="currentColor" 
  stroke-width="2" 
  stroke-linecap="round" 
  stroke-linejoin="round"
>
  <path d="M20 6 9 17l-5-5"/>
</svg>`, S = {
  "top-right": "copy-code-vue-position-tr",
  "top-left": "copy-code-vue-position-tl",
  "bottom-right": "copy-code-vue-position-br",
  "bottom-left": "copy-code-vue-position-bl"
}, q = (a, e) => {
  const {
    selector: c = "pre code",
    position: i = "top-right",
    copyMessage: p = "Copied",
    copyMessageTimeout: y = 2e3,
    containerClassName: f = "copy-code-vue-button-container",
    buttonClassName: C = "copy-code-vue-button",
    successClassName: b = "copy-code-vue-success",
    highlightOnCopy: x = !1
  } = a;
  if (typeof window > "u")
    return;
  const v = g([]);
  M(() => {
    const r = (e == null ? void 0 : e.value) || document, s = document.createElement("style");
    document.head.querySelector("#copy-code-vue-styles") || (s.id = "copy-code-vue-styles", s.textContent = `
        .copy-code-vue-wrapper pre {
          position: relative;
        }
        
        .copy-code-vue-button-container {
          position: absolute;
          z-index: 100;
          pointer-events: auto;
        }
        
        .copy-code-vue-position-tr {
          top: 8px;
          right: 8px;
        }
        
        .copy-code-vue-position-tl {
          top: 8px;
          left: 8px;
        }
        
        .copy-code-vue-position-br {
          bottom: 8px;
          right: 8px;
        }
        
        .copy-code-vue-position-bl {
          bottom: 8px;
          left: 8px;
        }
        
        .copy-code-vue-button {
          display: flex;
          align-items: center;
          justify-content: center;
          padding: 8px;
          background-color: rgb(50,58,80);
          border: 1px solid rgb(79,84,104);
          border-radius: 4px;
          cursor: pointer;
          transition: all 0.2s ease;
          pointer-events: auto;
          color: currentColor;
          opacity: 0.8;
        }
        
        .copy-code-vue-button:hover {
          background-color: rgb(79,84,104);
          border-color: rgb(86,90,105);
          opacity: 1;
        }
        
        .copy-code-vue-button:focus {
          outline: none;
        }
        
        .copy-code-vue-success {
          color:rgb(30, 218, 155);
        }
        
        @keyframes copy-code-vue-fade-in {
          from { opacity: 0; }
          to { opacity: 1; }
        }
        
        .copy-code-vue-fade-in {
          animation: copy-code-vue-fade-in 0.5s ease-in-out;
        }
        
        .copy-code-vue-highlight {
          transition: filter 0.15s ease-in-out;
          -webkit-filter: invert(80%);
          filter: invert(80%);
        }
        
        .copy-code-vue-flex {
          display: flex;
          align-items: center;
          gap: 4px;
        }
      `, document.head.appendChild(s)), r.querySelectorAll(c).forEach((n) => {
      const t = n.parentElement;
      if (!t || t.tagName !== "PRE" || t.querySelector(".copy-code-vue-button-element"))
        return;
      t.style.position = "relative";
      const u = document.createElement("div");
      u.className = `${f} ${S[i]} copy-code-vue-button-container-element`;
      const o = document.createElement("button");
      o.className = `${C} copy-code-vue-button-element`, o.setAttribute("aria-label", "Copy code"), o.innerHTML = d;
      const m = (h) => {
        h.preventDefault(), h.stopPropagation();
        let k = n.textContent || "";
        navigator.clipboard.writeText(k).then(() => {
          x && t && (t.classList.add("copy-code-vue-highlight"), setTimeout(() => {
            t.classList.remove("copy-code-vue-highlight");
          }, 400)), o.innerHTML = `<div class="${b} copy-code-vue-flex copy-code-vue-fade-in">
              ${p ? `<div>${p}</div>` : ""}
              ${H}
            </div>`, setTimeout(() => {
            o.innerHTML = d;
          }, y);
        }).catch((w) => {
          console.error("Failed to copy code:", w), o.innerHTML = '<div class="copy-code-vue-fade-in" style="color: #ef4444;">Failed to copy!</div>', setTimeout(() => {
            o.innerHTML = d;
          }, y);
        });
      };
      o.addEventListener("click", m), v.value.push(() => o.removeEventListener("click", m)), u.appendChild(o), t.appendChild(u);
    });
  }), N(() => {
    v.value.forEach((r) => r()), e != null && e.value && e.value.querySelectorAll(c).forEach((s) => {
      const l = s.parentElement;
      if (l) {
        const n = l.querySelector(".copy-code-vue-button-container");
        n && l.removeChild(n);
      }
    });
  });
}, O = /* @__PURE__ */ E({
  __name: "CopyCode",
  props: {
    customClass: { default: "" },
    selector: { default: "pre code" },
    position: { default: "top-right" },
    copyMessage: { default: "Copied" },
    copyMessageTimeout: { default: 2e3 },
    containerClassName: { default: "copy-code-vue-button-container" },
    buttonClassName: { default: "copy-code-vue-button" },
    successClassName: { default: "copy-code-vue-success" },
    highlightOnCopy: { type: Boolean, default: !1 }
  },
  setup(a) {
    const e = a, c = g(null);
    return q({
      selector: e.selector,
      position: e.position,
      copyMessage: e.copyMessage,
      copyMessageTimeout: e.copyMessageTimeout,
      containerClassName: e.containerClassName,
      buttonClassName: e.buttonClassName,
      successClassName: e.successClassName,
      highlightOnCopy: e.highlightOnCopy
    }, c), (i, p) => (B(), T("div", {
      ref_key: "containerRef",
      ref: c,
      class: L(i.customClass)
    }, [
      $(i.$slots, "default")
    ], 2));
  }
});
export {
  O as CopyCode,
  q as useCopyCode
};
